#pragma once

#include <vector>
#include <string>
#include <ReImage/flags.h>
#include <Color4.hpp>

namespace ReImage {
    class Image {
    private:
        unsigned int width = 0;
        unsigned int height = 0;
        TextureFormat format;
        TextureFlag flags;
        Image(std::vector<unsigned char>& pixel_data, TextureFormat format, unsigned int width, unsigned int height);
        void load(const std::string& file);
        void loadBMP(const std::string& file);
        void loadPNG(const std::string& file);
        void invertY();
    public:
        std::vector<unsigned char> pixel_data;
        Image(const std::string& file, const TextureFlag& flags);
        Image(const Color4* data, const size_t& length, unsigned int width, unsigned int height, TextureFlag flags = TextureFlag::NONE);
        Image(const Color3* data, const size_t& length, unsigned int width, unsigned int height, TextureFlag flags = TextureFlag::NONE);
        Image downscale(unsigned int rhs);
        [[nodiscard]] unsigned int getWidth() const;
        [[nodiscard]] unsigned int getHeight() const;
        TextureFormat getTextureFormat();
        TextureFlag getFlags();
    };
}